Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/lim2.card
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/lim2.card	(revision 2528)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/lim2.card	(revision 2575)
@@ -21,5 +21,5 @@
 
 [OutputFiles]
-List=   (${PREFIX_WFI1}_icemod.nc, ${R_OUT_ICE_WFI1}/${PREFIX}_${WFI1}_icemod.nc, Post_5D_icemod)
+List=   (${PREFIX_WFI1}_icemod.nc, ${R_OUT_ICE_WFI1}/${PREFIX}_${WFI1}_icemod.nc, Post_1M_icemod)
 
 [Post_1M_icemod]
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card	(revision 2528)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.card	(revision 2575)
@@ -8,6 +8,6 @@
 #-- available directories are:  v3, v3_1, v3_2
 #-- related to NEMO_tag_revision (nemo_v3, nemo_v3_1, nemo_v3_2_beta)
-#-- NOTE: if you use your own directory you have to comment it
-OPA_version=v3_2
+#-- NOTE: if you use COMMON ACCOUNT you have to de-comment it
+#OPA_version=v3_2
 #==============================================================
 
@@ -21,7 +21,7 @@
 
 [Interannual]
-#=====================================================================
-#-- Surface Boundary Condition original files name ( get by the job )
-#=====================================================================
+#==================================================================================================
+#-- Surface Boundary Condition original files name ( get by the job ) same as the ones in namelist
+#==================================================================================================
 #-- NOTE: MANDATORY STRUCTURE OF FILE NAMES GET BY THE JOB : 
 #-- "basename_yyyy.nc"  	( for interannual data )
@@ -30,19 +30,10 @@
 
 # default climatology, bulk_clio: 
-List_jobsbc=(flx, taux_1m, tauy_1m)
-# example for interannual, bulk core:
+#List_jobsbc=(flx, taux_1m, tauy_1m)
+# example for interannual, bulk core, forcing CORE2:
+List_jobsbc=(u_10.15JUNE2009_orca2, v_10.15JUNE2009_orca2, ncar_rad.15JUNE2009_orca2, t_10.15JUNE2009_orca2, q_10.15JUNE2009_orca2, ncar_precip.15JUNE2009_orca2)
+# example for interannual, bulk core, forcing DRAKKAR:
 #List_jobsbc=(radlw_DFS4-ORCA2, radsw_DFS4-ORCA2, q2_DFS4-ORCA2, t2_DFS4-ORCA2, u10_DFS4-ORCA2, v10_DFS4-ORCA2, snow_DFS4-ORCA2, precip_DFS4-ORCA2)
 
-#==========================================================================================
-#-- Surface Boundary Condition files name expected by NEMO ( same as the ones in namelist )
-#==========================================================================================
-#-- NOTE: 2 possible cases :
-#-- 1) put in List_runsbc file names different from List_jobsbc but identical to the ones in namelist
-#-- 2) leave List_runsbc empty so NEMO will read file names specified in List_jobsbc variable above
-
-# default climatology, bulk_clio: 
-List_runsbc=()
-# example for interannual, bulk core:
-#List_runsbc=(qlw_core, qsw_core, q2_core, t2_core, u10_core, v10_core, snow_core, precip_core)
 
 [InitialStateFiles]
@@ -54,13 +45,18 @@
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/bathy_level.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/bathy_meter.nc, .), \
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/bathy_updated.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/coordinates.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/data_1m_potential_temperature_nomask.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/data_1m_salinity_nomask.nc, .), \
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/geothermal_heating.nc, .),\
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/runoff_1m_nomask.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/runoff_core_monthly.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sss_data.nc, .),\
             (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/sst_data.nc, .),\
-            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/subbasins.nc, .)
+	    (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/subbasins.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/chlorophyll.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/K1rowdrg.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/M2rowdrg.nc, .),\
+            (${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/mask_itf.nc, .)
+
+
 
 
@@ -79,8 +75,8 @@
 List=   (${PREFIX_WF1}_grid_T.nc,         ${R_OUT_OCE_WF1}/${PREFIX}_${WF1}_grid_T.nc,               Post_1Y_grid_T),\
         (${PREFIX_WF2}_grid_T.nc,         ${R_OUT_OCE_WF2}/${PREFIX}_${WF2}_grid_T.nc,               Post_1M_grid_T),\
-        (${PREFIX_WF3}_grid_T.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_T.nc,               Post_5D_grid_T),\
-        (${PREFIX_WF3}_grid_U.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_U.nc,               Post_5D_grid_U) ,\
-        (${PREFIX_WF3}_grid_V.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_V.nc,               Post_5D_grid_V),\
-        (${PREFIX_WF3}_grid_W.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_W.nc,               Post_5D_grid_W),\
+        (${PREFIX_WF3}_grid_T.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_T.nc,               Post_1M_grid_T),\
+        (${PREFIX_WF3}_grid_U.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_U.nc,               Post_1M_grid_U) ,\
+        (${PREFIX_WF3}_grid_V.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_V.nc,               Post_1M_grid_V),\
+        (${PREFIX_WF3}_grid_W.nc,         ${R_OUT_OCE_WF3}/${PREFIX}_${WF3}_grid_W.nc,               Post_1M_grid_W),\
         (${PREFIX_WF4}_grid_T_0n180w.nc,  ${R_OUT_OCE_WF4}/${PREFIX}_${WF4}_grid_T_0n180w.nc,        NONE ),\
         (${PREFIX_WF4}_grid_T_Eq.nc,      ${R_OUT_OCE_WF4}/${PREFIX}_${WF4}_grid_T_Eq.nc,            NONE ),\
@@ -91,4 +87,9 @@
 
 
+[Post_1Y_grid_T]
+Patches = (Patch_20091030_histcom_time_axis)
+GatherWithInternal = (nav_lon, nav_lat, deptht, time_counter)
+TimeSeriesVars = (sohtc300, sohefldo, soicecov, somxl010, sosaline, sossheig, sosstsst, sowaflcd, sowaflup)
+
 [Post_1M_grid_T]
 Patches = (Patch_20091030_histcom_time_axis)
@@ -96,25 +97,15 @@
 TimeSeriesVars = (sohtc300, sohefldo, soicecov, somxl010, sosaline, sossheig, sosstsst, sowaflcd, sowaflup)
 
-[Post_1Y_grid_T]
-Patches = (Patch_20091030_histcom_time_axis)
-GatherWithInternal = (nav_lon, nav_lat, deptht, time_counter)
-TimeSeriesVars = (sohtc300, sohefldo, soicecov, somxl010, sosaline, sossheig, sosstsst, sowaflcd, sowaflup)
-
-[Post_5D_grid_T]
-Patches = (Patch_20091030_histcom_time_axis)
-GatherWithInternal = (nav_lon, nav_lat, deptht, time_counter)
-TimeSeriesVars = (sohtc300, sohefldo, soicecov, somxl010, sosaline, sossheig, sosstsst, sowaflcd, sowaflup)
-
-[Post_5D_grid_U]
+[Post_1M_grid_U]
 Patches = (Patch_20091030_histcom_time_axis)
 GatherWithInternal = (nav_lon, nav_lat, depthu, time_counter)
 TimeSeriesVars = (sozotaux)
 
-[Post_5D_grid_V]
+[Post_1M_grid_V]
 Patches = (Patch_20091030_histcom_time_axis)
 GatherWithInternal = (nav_lon, nav_lat, depthv, time_counter)
 TimeSeriesVars = (sometauy)
 
-[Post_5D_grid_W]
+[Post_1M_grid_W]
 Patches = (Patch_20091030_histcom_time_axis)
 GatherWithInternal = (nav_lon, nav_lat, depthw, time_counter)
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.driver
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.driver	(revision 2528)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/COMP/opa9.driver	(revision 2575)
@@ -51,7 +51,5 @@
     # Definition from opa9.card of List_jobsbc and List_runsbc used to do to interannual and climatological runs 
 	IGCM_card_DefineArrayFromOption ${SUBMIT_DIR}/COMP/opa9.card Interannual List_jobsbc
-	IGCM_card_DefineArrayFromOption ${SUBMIT_DIR}/COMP/opa9.card Interannual List_runsbc
         set -A ListFormulationJobsbc -- \${opa9_Interannual_Listjobsc${opa9_Interannual_List_jobsbc}[*]}
-        set -A ListFormulationRunsbc -- \${opa9_Interannual_Listrunsbc${opa9_Interannual_List_runsbc}[*]}
 
     ##--Variables used for XMLIO_SERVER configuration file
@@ -71,49 +69,77 @@
     if [ X${opa9_UserChoices_Interannual_Run} = Xy ] ; then
 
-	typeset file fileo
-
-        eval NbFileInter=${#opa9_Interannual_List_jobsbc[*]}
-
+	typeset file 
+
+ 	(( PeriodCumulPeriod =  ${CumulPeriod} - 1 )) 
+ 	(( PeriodInitYear =${InitYear} + ${PeriodCumulPeriod} * ${PeriodLengthInYears} ))
+ 	(( PeriodFinalYear =${InitYear} + ${PeriodLengthInYears}*${CumulPeriod} - 1 ))
+
+        NbFileInter=${#opa9_Interannual_List_jobsbc[*]}
+        (( NbFileInter_tot=${#opa9_Interannual_List_jobsbc[*]} * ${PeriodLengthInYears} ))
 	(( i = 0 ))
-	while [ $i -lt ${NbFileInter} ] ; do
-	    eval file=${opa9_Interannual_List_jobsbc[$i]}
-	    eval jobsbc_file_ym1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year - 1 )).nc
-	    eval jobsbc_file_y=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_${year}.nc
-	    eval jobsbc_file_yp1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year + 1 )).nc
-     # Copy of List_jobsbc in List_runsbc if this last one is empty 
-            if [ X${opa9_Interannual_List_runsbc[0]} = X${NULL_STR} ] ; then
-	    	eval fileo=${opa9_Interannual_List_jobsbc[$i]}
-            	eval runsbc_file_ym1=${file}_y$(( year - 1 )).nc
-            	eval runsbc_file_y=${file}_y${year}.nc
-            	eval runsbc_file_yp1=${file}_y$(( year + 1 )).nc
-	    else
-	    	eval fileo=${opa9_Interannual_List_runsbc[$i]}
-            	eval runsbc_file_ym1=${fileo}_y$(( year - 1 )).nc
-            	eval runsbc_file_y=${fileo}_y${year}.nc
-            	eval runsbc_file_yp1=${fileo}_y$(( year + 1 )).nc
-	   fi
-
-	    if [ X${Period} = X1 ] ; then
-		if [ ${month} -eq 01 ] ; then
-		    IGCM_sys_Get ${jobsbc_file_ym1} ${runsbc_file_ym1}
+
+	while [ ${year} -le ${PeriodFinalYear} ] ; do #copy in ONCE of ALL necessary files for all PeriodLength
+	    
+	    while [ $i -lt ${NbFileInter} ] ; do
+		
+		eval file=${opa9_Interannual_List_jobsbc[$i]}
+		if [ X${year} = X${PeriodInitYear} ] ; then  
+                        	if [ ${month} -eq 01 ] ; then
+		    			# if year-1 does not exist we create a file _noym1.nc copy of year
+		    			eval jobsbc_file_ym1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year - 1 )).nc
+		    			if  [ ! -f ${jobsbc_file_ym1} ] ; then
+		    				eval jobsbc_file_ym1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_${year}.nc
+		    				eval runsbc_file_ym1=${file}_noym1.nc
+		    			else
+		    			    eval jobsbc_file_ym1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year - 1 )).nc
+		    			    eval runsbc_file_ym1=${file}_y$(( year - 1 )).nc
+		    			fi
+
+                            IGCM_sys_Get ${jobsbc_file_ym1} ${runsbc_file_ym1}
+                        	fi
 		fi
+		
+       		# download year 
+		eval jobsbc_file_y=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_${year}.nc
+		eval runsbc_file_y=${file}_y${year}.nc
+		
 		if [ ! -f ${runsbc_file_y} ] ; then
 		    IGCM_sys_Get ${jobsbc_file_y} ${runsbc_file_y}
 		fi
-		if [ ! -f ${runsbc_file_yp1} ] ; then
-		    IGCM_sys_Get ${jobsbc_file_yp1} ${runsbc_file_yp1}
+		
+		# download (year+1) if it is last year of run
+		if [ X${year} = X${PeriodFinalYear} ] ; then 	
+	
+		    eval jobsbc_file_yp1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year + 1 )).nc
+		    eval runsbc_file_yp1=${file}_y$(( year + 1 )).nc
+		    
+		    if  [ ! -f ${runsbc_file_yp1} ] ; then
+			
+		        # if year+1 does not exist we create a file _noyp1.nc copy of year
+		    	eval jobsbc_file_yp1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year + 1 )).nc
+			if  [ ! -f ${jobsbc_file_yp1} ] ; then
+			    eval jobsbc_file_yp1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_${year}.nc
+		    	    eval runsbc_file_yp1=${file}_noyp1.nc
+			else
+			    eval jobsbc_file_yp1=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}_$(( year + 1 )).nc
+			    eval runsbc_file_yp1=${file}_y$(( year + 1 )).nc
+			fi
+			IGCM_sys_Get ${jobsbc_file_yp1} ${runsbc_file_yp1}
+		    fi
+		    
 		fi
-	    else 
-		if [ ! -f ${runsbc_file_yp1} ] ; then
-		    IGCM_sys_Get ${jobsbc_file_yp1} ${runsbc_file_yp1}
-		fi
-	    fi 
-
-	    (( i = i + 1 ))
+		(( i = i + 1 ))
+	
+	    done
+	
+	    (( year = year + 1 ))
+	 
+	    (( i = 0 ))
 	done
+
     # End interannual
     elif [ X${opa9_UserChoices_Interannual_Run} = Xn ] ; then
     # Climatological run
-       typeset file fileo
+       typeset file 
 
        eval NbFileInter=${#opa9_Interannual_List_jobsbc[*]}
@@ -123,11 +149,5 @@
             eval file=${opa9_Interannual_List_jobsbc[$i]}
             eval jobsbc_file=${R_BC}/OCE/${config_UserChoices_TagName}/${opa9_UserChoices_OPA_version}/${file}.nc
-            if [ X${opa9_Interannual_List_runsbc[0]} = X${NULL_STR} ] ; then
-	    	eval fileo=${opa9_Interannual_List_jobsbc[$i]}
-            	eval runsbc_file=${fileo}.nc
-	    else
-	    	eval fileo=${opa9_Interannual_List_runsbc[$i]}
-            	eval runsbc_file=${fileo}.nc
-	   fi
+            eval runsbc_file=${file}.nc
 
             IGCM_sys_Get ${jobsbc_file} ${runsbc_file}
@@ -224,16 +244,17 @@
 	NEMO_END=$( echo $( awk "BEGIN { printf \"%0${PRECIS}d\",${OPA_NITEND} }" ) ) 
 
-    sed -e "s%${PAT_CEXPER}%       cn_exp=\"${config_UserChoices_JobName}\"%" \
+    sed -e "s%${PAT_CEXPER}%       cn_exp=\"${config_UserChoices_JobName}\"%"  \
 	-e "s%${PAT_NIT000}%       nn_it000=${OPA_NIT000}%"                    \
 	-e "s%${PAT_NITEND}%       nn_itend=${OPA_NITEND}%"                    \
-	-e "s%${PAT_RESTAR}%       ln_rstart=${OPA_LRSTAR}%"                 \
+	-e "s%${PAT_RESTAR}%       ln_rstart=${OPA_LRSTAR}%"                   \
 	-e "s%${PAT_NSTOCK}%       nn_stock=${OPA_NSTOCK}%"                    \
-	-e "s%${PAT_NRSTAR}%       nn_rstctl=${OPA_NRSTDT}%"                    \
-	-e "s%${PAT_NDATE0}%       nn_date0=${PeriodDateBegin}%"                \
+	-e "s%${PAT_NRSTAR}%       nn_rstctl=${OPA_NRSTDT}%"                   \
+	-e "s%${PAT_NDATE0}%       nn_date0=${PeriodDateBegin}%"               \
 	-e "s%${PAT_NMSH}%         nn_msh=${OPA_NMSH}%"                        \
-	-e "s%${PAT_NLEAPY}%       nn_leapy=${OPA_NLEAPY}%"	              \
+	-e "s%${PAT_NLEAPY}%       nn_leapy=${OPA_NLEAPY}%"	               \
 	namelist > namelist.tmp
 
     IGCM_sys_Mv namelist.tmp namelist
+
 
     # update xmlio_server.def
Index: trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/config.card
===================================================================
--- trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/config.card	(revision 2528)
+++ trunk/NEMOGCM/CONFIG/ORCA2_LIM_PISCES/IGCM00/config.card	(revision 2575)
@@ -52,5 +52,5 @@
 Name=nemo
 #D- For each component, Real name of executable
-OCE= (opa_pisces_iomput, nemo)
+OCE= (nemo.exe, nemo)
 ICE= ("", "")
 MBG= ("", "")