Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 2638)
@@ -39,4 +39,5 @@
    USE obs_types                ! Definitions for observation types
    USE mpp_map                  ! MPP mapping
+   USE lib_mpp                  ! For ctl_warn/stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/julian.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/julian.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/julian.F90	(revision 2638)
@@ -13,6 +13,8 @@
       & wp, &
       & dp  
-   USE in_out_manager           ! I/O manager
-  
+   !USE in_out_manager           ! I/O manager
+   USE lib_mpp,  ONLY : &
+      & ctl_warn, ctl_stop
+
    IMPLICIT NONE
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_grid.F90	(revision 2638)
@@ -33,5 +33,7 @@
    USE obs_const, ONLY :      &
       & obfillflt                  ! Fillvalue   
-   
+   USE lib_mpp, ONLY :   &
+      & ctl_warn, ctl_stop
+
    IMPLICIT NONE
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_h2d.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_h2d.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_inter_h2d.F90	(revision 2638)
@@ -28,5 +28,7 @@
       & obfillflt		! Fillvalue
    USE obs_utils           ! Utility functions
-   
+      USE lib_mpp,ONLY : &
+      & ctl_warn, ctl_stop
+
    IMPLICIT NONE
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_oper.F90	(revision 2638)
@@ -38,4 +38,6 @@
       & glamt, glamu, glamv, &
       & gphit, gphiu, gphiv
+   USE lib_mpp,       ONLY : &
+      & ctl_warn, ctl_stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 2638)
@@ -27,4 +27,6 @@
    USE obs_inter_sup      ! Interpolation support
    USE obs_oper           ! Observation operators
+   USE lib_mpp, ONLY : &
+      & ctl_warn, ctl_stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_profiles_def.F90	(revision 2638)
@@ -29,4 +29,6 @@
       obs_mpp_sum_integers
    USE obs_fbm            ! Obs feedback format
+   USE lib_mpp, ONLY : &
+      & ctl_warn, ctl_stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 2638)
@@ -26,4 +26,5 @@
    USE obs_oper                 ! Observation operators
    USE obs_prof_io              ! Profile files I/O (non-FB files)
+   USE lib_mpp                  ! For ctl_warn/stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90	(revision 2638)
@@ -26,4 +26,5 @@
    USE obs_oper                 ! Observation operators
    USE obs_vel_io               ! Velocity profile files I/O (non-FB files)
+   USE lib_mpp                  ! For ctl_warn/stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readmdt.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readmdt.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_readmdt.F90	(revision 2638)
@@ -41,4 +41,5 @@
    USE iom_nf90   
    USE netcdf                   ! NetCDF library
+   USE lib_mpp                  ! For ctl_warn/stop
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_utils.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_utils.F90	(revision 2637)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/OBS/obs_utils.F90	(revision 2638)
@@ -19,5 +19,6 @@
       & i8  
    USE in_out_manager           ! I/O manager
-  
+   USE lib_mpp                  ! For ctl_warn/stop
+
    IMPLICIT NONE
 